c  Program for determining tertiary class
c  Based on Venyaminov and Vassilenko (1994) Anal.biochem.                   
c  Modified for use with CDPro suite of programs
c
	character*9 Class(5)
	character*1 ititle(80)
	character*1 title(90)
	dimension CD(83), CD1(25)
	dimension weight(5,5,25),Prdct(5,5),NClass(5)
	dimension PlsAlf(25),SlsAlf(25),SlsPls(25),BetAlf(25),BetPls(25),
     1           BetSls(25),DenAlf(25),DenPls(25),DenSls(25),DenBet(25)
c
	write(*,901)
901	format(80('_')//
     1  ' This program CLUSTER determines the tertiary structure Class'
     2 /' From CD data- Uses INPUT - and modifies INPUT file(IBAS=8)'
     3 /' Creates the CDDATA.CA and SSDATA.CA for the CD spectrum'
     4 /' Output is in CLUSTER.OUT' /)
c
	Class(1) = 'All Alpha'
	Class(2) = 'Alfa+Beta'
	Class(3) = 'Alfa/Beta'
	Class(4) = 'All Beta '
	Class(5) = 'Denatured'
c
	open(unit=3,file='plusalfa')
	read(3,*)(PlsAlf(i),i=1,25)
	close(3)
	open(unit=3,file='slshalfa')
	read(3,*)(SlsAlf(i),i=1,25)
	close(3)
	open(unit=3,file='slshplus')
	read(3,*)(SlsPls(i),i=1,25)
	close(3)
	open(unit=3,file='betaalfa')
	read(3,*)(BetAlf(i),i=1,25)
	close(3)
	open(unit=3,file='betaplus')
	read(3,*)(BetPls(i),i=1,25)
	close(3)
	open(unit=3,file='betaslsh')
	read(3,*)(BetSls(i),i=1,25)
	close(3)
	open(unit=3,file='dentalfa')
	read(3,*)(DenAlf(i),i=1,25)
	close(3)
	open(unit=3,file='dentplus')
	read(3,*)(DenPls(i),i=1,25)
	close(3)
	open(unit=3,file='dentslsh')
	read(3,*)(DenSls(i),i=1,25)
	close(3)
	open(unit=3,file='dentbeta')
	read(3,*)(DenBet(i),i=1,25)
	close(3)
c
	OPEN (unit=3,file='INPUT')
	OPEN (unit=4,file='CLUSTER.OUT')
c
	do i=1,25
	   weight(2,1,i) = PlsAlf(i)
	   weight(1,2,i) = PlsAlf(i)
	   weight(3,1,i) = SlsAlf(i)
	   weight(1,3,i) = SlsAlf(i)
	   weight(3,2,i) = SlsPls(i)
	   weight(2,3,i) = SlsPls(i)
	   weight(4,1,i) = BetAlf(i)
	   weight(1,4,i) = BetAlf(i)
	   weight(4,2,i) = BetPls(i)
	   weight(2,4,i) = BetPls(i)
	   weight(4,3,i) = BetSls(i)
	   weight(3,4,i) = BetSls(i)
	   weight(5,1,i) = DenAlf(i)
	   weight(1,5,i) = DenAlf(i)
	   weight(5,2,i) = DenPls(i)
	   weight(2,5,i) = DenPls(i)
	   weight(5,3,i) = DenSls(i)
	   weight(3,5,i) = DenSls(i)
	   weight(5,4,i) = DenBet(i)
	   weight(4,5,i) = DenBet(i)
	enddo
c	do i=1,25
c	   write(4,600) PlsAlf(i),SlsAlf(i),SlsPls(i),BetAlf(i),BetPls(i),
c     1            BetSls(i),DenAlf(i),DenPls(i),DenSls(i),DenBet(i)
c	enddo
600	format(10f8.3)
c
c Input
c
        write(*,400)
        write(*,450)
        write(4,450)
        write(4,400)
        write(4,450)
c
1	Continue
c
	do i=1,5
	   NClass(i) = 0
	enddo
c
        read(3,*,end=99)
        read(3,*)
        read(3,*)
        read(3,*)
	read(3,*)
        read(3,100) ititle
	read(3,*)
	write(4,100) 
	write(4,100) ititle
	write(*,100) 
	write(*,100) ititle
	read(3,*)
	read(3,*)Wbegin,Wend, FACTOR
	read(3,*)
	NCD = INT(wbegin-wend) + 1
	NCDN = NCD
c
	 WvStrt = 236.0
	 WvEnd  = 190.0
	if((wbegin.GT.WvStrt).OR.(wend.LT.WvEnd))   then
		write(4,470) wbegin,wend,WvStrt, WvEnd, ncd
	   	Iskip = Wbegin - WvStrt
		if(Wbegin.GT.WvStrt) Wbegin = WvStrt
		if(Wend.LT.WvEnd) Wend = WvEnd
	      	NCDN = Int(Wbegin - Wend) + 1
	endif
c
	read(3,*)
	read(3,*)(CD(i),i=1,ncd)
	read(3,*)
	read(3,*)
	read(3,*)
c
	if(factor.EQ.0.0) Factor = 1.0
	 do 51 i=1,Ncdn
		CD(i)=CD(i+Iskip)*factor
51	 Continue
	ncd = ncdn
c
	k=24
	do i=1,ncd,2
	  CD1(k) = CD(i)
	  k=k-1
	enddo
	CD1(25) = 1.0
c
	k = 24
	write(*,500)wend,wbegin,k
	write(*,100) 
	write(*,600)(CD1(k),k=1,25)
	write(*,100) 
	write(4,500)wend,wbegin,k
	write(4,100) 
	write(4,600)(CD1(k),k=1,25)
	write(4,100) 
100     format(80a1)
450     format(/80('_')/)
400     format(
     1'  Determination of TERTIARY CLASS using the method of'/
     2'  Venyaminov and Vassilenko, Anal. Biochem. 222, 176 (1994)',
     3//'  Program Modified by Sreerama. N.(2000) for use with CDPro'
     4//'  The TERTIARY CLASSES are All-Alpha, All-beta, Alpha-Beta,
     5 and Denatured'/
     6 /'  CD analysis could be performed for former three classes')
500     format(/' Beginning wavelength:',f8.2,'; Ending wavelength:'
     1,f8.2,/' Total No of CD points',i4/)
470     format(//' The wavelength range: ',2f7.1,
     1   ', is different from that of',/,' Anal.Biochem.Paper:',2f7.1,
     2 /' The No. of CD points = ',i4, 
     3 //' The wavelengths are modified to be within the valid range')
c
	write(4,100) 
	write(4,150)
150	format('  Weight*CD    Class          Class'/
     1         '--------------------------------------------')
	do i=2,5
	do k=1,i-1
	   prdct(k,i) = 0.0
	   do j=1,25
	      prdct(k,i) = prdct(k,i) + CD1(j) * weight(i,k,j)
	   enddo
	   If(prdct(k,i).GT.0.0) then
	     write(4,200)prdct(k,i),class(i),class(k)
	     NClass(i) = NClass(i) + 1
	   Else
	     write(4,300)prdct(k,i),class(i),class(k)
	     NClass(k) = NClass(k) + 1
	   Endif
	enddo
	enddo
200	format(f10.3,3x,a9,' + ',3x,a9,'  - ')
300	format(f10.3,3x,a9,' - ',3x,a9,'  + ')
c
	write(4,100) 
	write(4,160) 
160	format('      Class     Score'/
     1         '--------------------------')
	do i=1,5
	   Write(4,401)class(i),NClass(i)
	enddo
401	format(4x,a9,i5)
c
	max = NClass(1)
	maxind = 1
	do i=2,5
	  if(max.LT.NClass(i)) then
	      max = NClass(i)
	      maxind = i
	  endif
	enddo
	write(4,702) max
702	format(/'  Maximum Score Obtained:',i3)
	Iclas1 = 0
	Iclas2 = 0
	do i=1,5
	   if(max.EQ.NClass(i))then
		If(Iclas1.NE.0) then
	 	   IClas2 = i
		else
	 	   IClas1 = i
		Endif
		write(4,710)class(i)
		write(*,710)class(i)
	   endif
	enddo
710	format('  PREDICTED Tertiary Class: ',a9)
	Write(4,721)
	Write(*,721)
721	format(//'  Program has created CDDATA.CA and SSDATA.CA'/
     1 '    containing reference proteins from this specific class'/
     1           '  The INPUT file now has Bas1 = 8'/
     2           '  You may RUN CD ANALYSIS PROGRAMS NOW'/)

c
	write(*,100) 
	write(*,100) 
	write(*,450)
	write(4,450)
	If(IClas1.EQ.5)write(4,460)
460	format(/'  The class determined is Denatured'/
     1          '  The CD analysis can be performed with Bas1 = 7')
	If(IClas2.EQ.5)write(4,461)class(IClas1)
461	format(/'  The Classes determined are Denatured and ',A9/
     1          '  You may repeat the CD analysis with Bas1 = 7')
c
c Modify INPUT: Copy Unit 3 to Unit 2
c
	open (unit=2,File='CLUSTMP')
	rewind(3)
	read(3,100)ititle
	write(2,100)ititle
	read(3,100)ititle
	write(2,100)ititle
	read(3,*)i1,i2,i3,i4,i5
	i2 = 8
	If(IClas1.EQ.5) i2 = 7
	write(2,'(5(4x,i4))')i1,i2,i3,i4,i5
231	continue
	read(3,100,end=239)ititle
	write(2,100)ititle
	goto 231
239	continue
c
	rewind(3)
	rewind(2)
c
c Copy Unit 2 to UNit 3 (INPUT)
c
241	continue
	read(2,100,end=249)ititle
	write(3,100)ititle
	goto 241
249	continue
	close(3)
	close(2)
	close(4)
c
c Create CDDATA.CA and SSDATA.CA
c
	open(unit = 2, file='CDDATA.CA')
	open(unit = 3, file='SSDATA.CA')
	Write(2,270)
	write(2,*)
270	format('  CDDATA.CA; CDdata created from CLUSTER Program')
c
350	continue
c
	If(Iclas1.EQ.1) then
	  open(unit=8,file='CDDATA.AA')
	  open(unit=9,file='SSDATA.AA')
	Endif
	If(Iclas1.EQ.2.OR.IClas1.EQ.3) then
	  open(unit=8,file='CDDATA.AB')
	  open(unit=9,file='SSDATA.AB')
	Endif
	If(Iclas1.EQ.4) then
	  open(unit=8,file='CDDATA.BB')
	  open(unit=9,file='SSDATA.BB')
	Endif
	If(Iclas1.EQ.5) then
	  open(unit=8,file='CDDATA.48')
	  open(unit=9,file='SSDATA.48')
	Endif
c	
	read(8,*)
	read(8,*)
c
110	format(90a1)
331	continue
	read(8,110,end=339)title
	write(2,110)title
	goto 331
339	continue
c
431	continue
	read(9,100,end=439)ititle
	write(3,100)ititle
	goto 431
439	continue
c
	close(8)
	close(9)
c
	if(IClas1.EQ.2.AND.IClas2.EQ.3) goto 99
	If(IClas2.NE.0.AND.IClas2.NE.5) then
	  IClas1 = IClas2
	  IClas2 = 0
	  GoTo 350
	Endif	
c
99	continue
	Close(2)
	Close(3)
c
	end
	
